local plscript = CreateFrame("Frame")
plscript:RegisterEvent("PLAYER_ENTERING_WORLD", unit)
plscript:RegisterEvent("ADDON_LOADED")
plscript:RegisterEvent("UNIT_EXITED_VEHICLE")
local function eventHandler(self,event)
	if event == "ADDON_LOADED" then
		if (player == nil) then
				player = {ref = "TOPLEFT", x = -20, y = -4}
				target = {ref = "TOPLEFT", x = 250, y = -4}
				focus = {ref = "CENTER", x = 250, y = -44}
				arena = {ref = "CENTER", x = 350, y = 50}
				hideMacro = false
				showClass = true
		end
	end
	if event == "PLAYER_ENTERING_WORLD" then
				-- FRAMES
				--[[OverrideActionBar:HookScript("OnShow", function(self)
							PlayerFrame:ClearAllPoints()
							PlayerFrame:SetPoint(player.ref, UIParent, player.x, player.y)
				end)
				OverrideActionBar:HookScript("OnHide", function(self)
							PlayerFrame:ClearAllPoints()
							PlayerFrame:SetPoint(player.ref, player.x, player.y)
				end)]]
				PlayerFrame:SetMovable(true)
				PlayerFrame:IsUserPlaced(true)
				PlayerFrame:ClearAllPoints()
				PlayerFrame:SetPoint(player.ref, player.x, player.y)
				TargetFrame:ClearAllPoints()
				TargetFrame:SetPoint(target.ref, target.x, target.y)
				FocusFrame:ClearAllPoints()
				FocusFrame:SetPoint(focus.ref, focus.x, focus.y)
				
				-- CLASS PORTRAITS
				if showClass == true then
					--[[UFP = "UnitFramePortrait_Update"
					UICC = "Interface\\TargetingFrame\\UI-Classes-Circles"
					CIT = CLASS_ICON_TCOORDS
					hooksecurefunc(UFP,function(self) if self.portrait then local t = CIT[select(2,UnitClass(self.unit))] if t then self.portrait:SetTexture(UICC) self.portrait:SetTexCoord(unpack(t)) end end end)
					]]hooksecurefunc("UnitFramePortrait_Update", function(self)
						if self.portrait and UnitIsPlayer(self.unit) and self.unit ~= "player" and self.unit ~= "pet" and self.unit ~= nil then
							local t = CLASS_ICON_TCOORDS[select(2, UnitClass(self.unit))]
							if t then
								self.portrait:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles")
								self.portrait:SetTexCoord(unpack(t))
							end
						else
							if self.portrait ~= nil then
								self.portrait:SetTexCoord(0,1,0,1)
							end
						end
					end)
				end
				
				-- BARS
					-- Hides macro text
				if hideMacro == true then
					for i=1,12 do _G["ActionButton"..i.."Name"]:SetAlpha(0) _G["MultiBarBottomRightButton"..i.."Name"]:SetAlpha(0) _G["MultiBarBottomLeftButton"..i.."Name"]:SetAlpha(0) _G["MultiBarRightButton"..i.."Name"]:SetAlpha(0) _G["MultiBarLeftButton"..i.."Name"]:SetAlpha(0) end
				end
				
					-- Hiding unnecessary things
				SpellActivationOverlayFrame:SetScale(.6)
				ActionBarUpButton:SetAlpha(0)
				ActionBarDownButton:SetAlpha(0)
				MainMenuBarPageNumber:SetAlpha(0)
				MainMenuBarLeftEndCap:SetAlpha(0)
				MainMenuBarRightEndCap:SetAlpha(0)
				UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE")
				MainMenuBarMaxLevelBar:SetAlpha(0)
				for i=0,3 do _G["MainMenuBarTexture"..i]:SetAlpha(0)end
				for i=0,3 do _G["MainMenuMaxLevelBar"..i]:SetAlpha(0)end
				
					-- Fix for frame auras
				TargetFrameToT:ClearAllPoints()
				TargetFrameToT:SetPoint("BOTTOMRIGHT",TargetFrame,-15,-10)
				FocusFrameToT:ClearAllPoints()
				FocusFrameToT:SetPoint("BOTTOMRIGHT",FocusFrame,-15,-10)
				
					-- Sexy Chat Frame
				for i=1,NUM_CHAT_WINDOWS do _G["ChatFrame"..i]:SetFont("Fonts\\ARIALN.TTF",15,"OUTLINE")end
				hooksecurefunc("FloatingChatFrame_Update",function(id, ...)
					_G["ChatFrame"..id]:SetFont("Fonts\\ARIALN.TTF",15,"OUTLINE")
				end)
				
				MainMenuBar:ClearAllPoints()
				MainMenuBar:SetPoint("BOTTOMLEFT", UIParent, "BOTTOM", -250, 35)
				MainMenuBarBackpackButton:ClearAllPoints()
				MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", MainMenuMicroButton, "TOPRIGHT", -3, -15)
				
				MultiBarBottomLeft:SetMovable(true)
				MultiBarBottomLeft:SetUserPlaced(true)
				MultiBarBottomLeft:ClearAllPoints()
				MultiBarBottomLeft:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 7)
				MultiBarBottomLeft:SetFrameStrata("BACKGROUND")
				--MultiBarBottomLeft.SetPoint = function() end
				
				MultiBarBottomRight:SetMovable(true)
				MultiBarBottomRight:SetUserPlaced(true)
				MultiBarBottomRight:ClearAllPoints()
				MultiBarBottomRight:SetPoint("BOTTOM",MultiBarBottomLeft,"TOP",0,5)
				MultiBarBottomRight:SetFrameStrata("BACKGROUND")
				--MultiBarBottomRight.SetPoint = function() end
				
					-- Pet Bars
				PetActionBarFrame:SetMovable(true)
				PetActionBarFrame:SetUserPlaced(true)
				PetActionBarFrame:ClearAllPoints()
				PetActionBarFrame:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton2, "TOPLEFT", -15, 7)
				PetActionBarFrame:SetFrameStrata("BACKGROUND")
				PetActionBarFrame.SetPoint = function() end
				
					-- Stance Bars
				StanceBarFrame:SetMovable(true)
				StanceBarFrame:SetUserPlaced(true)
				StanceBarFrame:ClearAllPoints()
				StanceBarFrame:SetPoint("BOTTOM", PetActionButton1, "TOP", 0, 7)
				StanceBarFrame:SetFrameStrata("BACKGROUND")
				StanceBarFrame.SetPoint = function() end
				
					-- Exp and Rep bars
				MainMenuExpBar:ClearAllPoints()
				MainMenuExpBar:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, 0)
				ReputationWatchBar:ClearAllPoints()
				ReputationWatchBar:SetPoint("BOTTOM", MainMenuExpBar, "TOP", 0, 3)
				hooksecurefunc("ReputationWatchBar_Update", function(newLevel)
					ReputationWatchBar:ClearAllPoints()
					ReputationWatchBar:SetPoint("BOTTOM", MainMenuExpBar, "TOP", 0, 3)
				end)
				
					-- ExtraActionButton1
				ExtraActionButton1:SetMovable(true)
				ExtraActionButton1:SetUserPlaced(true)
				--ExtraActionButton1:ClearAllPoints()
				--ExtraActionButton1:SetPoint("BOTTOM", StanceBarFrame, "TOP", 0, 3)
				--ExtraActionButton1.SetPoint = function() end
				ExtraActionButton1:HookScript("OnShow", function(self)
							self:ClearAllPoints()
							self:SetPoint("BOTTOM", StanceBarFrame, "TOP", 0, 5)
				end)
				
					-- Alternate Power Bar
				--PlayerPowerBarAlt:ClearAllPoints()
				--PlayerPowerBarAlt:SetPoint("BOTTOM", PetActionBarFrame, "TOP", 0 3)
				--PlayerPowerBarAlt.SetPoint = function() end
				
					-- ExitVehicle Button
				MainMenuBarVehicleLeaveButton:HookScript("OnShow", function(self)
							self:ClearAllPoints()
							self:SetPoint("BOTTOM", StanceBarFrame, "TOP", 0, 3)
				end)
				
					-- Red icons for out of range
				hooksecurefunc("ActionButton_OnEvent",function(self, event, ...)
                                if ( event == "PLAYER_TARGET_CHANGED" ) then
                                                self.newTimer = self.rangeTimer
                                end
                end)

                hooksecurefunc("ActionButton_UpdateUsable",function(self)
								local icon = self.icon
                                local valid = IsActionInRange(self.action)

                                if ( valid == 0 ) then
                                                icon:SetVertexColor(1.0, 0.1, 0.1) -- SetAlpha(0.3)SetVertexColor(1.0, 0.1, 0.1)
                                end
                end)

                hooksecurefunc("ActionButton_OnUpdate",function(self, elapsed)
                                local rangeTimer = self.newTimer

                                if ( rangeTimer ) then
                                                rangeTimer = rangeTimer - elapsed
												
                                                if ( rangeTimer <= 0 ) then
                                                                ActionButton_UpdateUsable(self)
                                                                rangeTimer = TOOLTIP_UPDATE_TIME
                                                end
												

                                                self.newTimer = rangeTimer
                                end
                end)
				
				CastingBarFrame:SetMovable(true)
				CastingBarFrame:SetUserPlaced(true)
				hooksecurefunc("CastingBarFrame_OnUpdate",function(self)
					if (self.casting) then
						CastingBarFrame:ClearAllPoints()
						CastingBarFrame:SetPoint("CENTER", UIParent, "CENTER", 0, -100)
					end
				end)
				
				--[[
				CastingBarFrame.timer = CastingBarFrame:CreateFontString(nil);
				CastingBarFrame.timer:SetFont(STANDARD_TEXT_FONT,12,"OUTLINE");
				CastingBarFrame.timer:ClearAllPoints()
				CastingBarFrame.timer:SetPoint("BOTTOM", CastingBarFrame, "TOP", 0, 7);
				CastingBarFrame.update = .1;
				

				hooksecurefunc("CastingBarFrame_OnUpdate", function(self, elapsed)
						if not self.timer then return end
						if self.update and self.update < elapsed then
								if self.casting then
										self.timer:SetText(format("%2.1f/%1.1f", max(self.maxValue - self.value, 0), self.maxValue))
								elseif self.channeling then
										self.timer:SetText(format("%.1f", max(self.value, 0)))
								else
										self.timer:SetText("")
								end
								self.update = .1
						else
								self.update = self.update - elapsed
						end
				end)
				]]
				-- HIDE PET DAMAGE PORTRAIT
				PlayerHitIndicator:SetText(nil)
				PlayerHitIndicator.SetText = function() end

				PetHitIndicator:SetText(nil)
				PetHitIndicator.SetText = function() end
				
				-- SCROLLABLE MINIMAP (HIDES +/- BUTTONS)
				Minimap:EnableMouseWheel(true)
				Minimap:SetScript('OnMouseWheel', function(self, delta)
						if delta > 0 then
								Minimap_ZoomIn()
						else
								Minimap_ZoomOut()
						end
				end)
				MiniMapTracking:ClearAllPoints()
				MiniMapTracking:SetPoint("TOPRIGHT", -26, 7)
				
				
	end
	if event == "UNIT_EXITED_VEHICLE" then
					-- Required for moving bars, overlays, back to proper position after exiting a vehicle.
				MainMenuBar:ClearAllPoints()
				MainMenuBar:SetPoint("BOTTOMLEFT", UIParent, "BOTTOM", -250, 35)
				MainMenuBarBackpackButton:ClearAllPoints()
				MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", MainMenuMicroButton, "TOPRIGHT", -3, -15)
				
				MultiBarBottomLeft:ClearAllPoints()
				MultiBarBottomLeft:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 7)
				MultiBarBottomLeft.SetPoint = function() end
				
				MultiBarBottomRight:ClearAllPoints()
				MultiBarBottomRight:SetPoint("BOTTOM",MultiBarBottomLeft,"TOP",0,5)
				MultiBarBottomRight.SetPoint = function() end
				
					-- Pet Bars
				PetActionBarFrame:ClearAllPoints()
				PetActionBarFrame:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton2, "TOPLEFT", -15, 7)
				
				
					-- Stance Bars
				StanceBarFrame:ClearAllPoints()
				StanceBarFrame:SetPoint("BOTTOM", PetActionButton1, "TOP", 0, 7)
				StanceBarFrame.SetPoint = function() end
				
					-- Exp and Rep bars
				MainMenuExpBar:ClearAllPoints()
				MainMenuExpBar:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, 0)
				ReputationWatchBar:ClearAllPoints()
				ReputationWatchBar:SetPoint("BOTTOM", MainMenuExpBar, "TOP", 0, 3)
				ReputationWatchBar.SetPoint = function() end
				
					-- ExtraActionButton1
				ExtraActionButton1:ClearAllPoints()
				ExtraActionButton1:SetPoint("BOTTOM", StanceBarFrame, "TOP", 0, 3)
				ExtraActionButton1.SetPoint = function() end
				
					-- ExitVehicle Button
				MainMenuBarVehicleLeaveButton:HookScript("OnShow", function(self)
							self:ClearAllPoints()
							self:SetPoint("BOTTOM", StanceBarFrame, "TOP", 0, 3)
				end)
	end
end
SLASH_POWERINTERFACE1, SLASH_POWERINTERFACE2 = '/powerui', '/pui';
local function handler(msg, editbox)
	local command, x, y = msg:match("^(%S*)%s*(-?%d+)%s*,%s*(-?%d+)$")
		--[[if msg == "lock" then
					player.ref, _, _, player.x, player.y = PlayerFrame:GetPoint()
					PlayerFrame:ClearAllPoints()
					PlayerFrame:SetPoint(player.ref, UIParent, player.ref, player.x, player.y)

					target.ref, _, _, target.x, target.y = TargetFrame:GetPoint()
					TargetFrame:ClearAllPoints()
					TargetFrame:SetPoint(target.ref, UIParent, target.ref, target.x, target.y)

					focus.ref, _, _, focus.x, focus.y = FocusFrame:GetPoint()
					FocusFrame:ClearAllPoints()
					FocusFrame:SetPoint(focus.ref, UIParent, focus.ref, focus.x, focus.y)
					print("Frames locked to their current positions.")]]
		if msg == "defaults" then
			player = {ref = "CENTER", x = -475, y = 175}
			target = {ref = "CENTER", x = -250, y = 175}
			focus = {ref = "CENTER", x = 250, y = 175}
			PlayerFrame:ClearAllPoints()
			PlayerFrame:SetPoint(player.ref, player.x, player.y)
			TargetFrame:ClearAllPoints()
			TargetFrame:SetPoint(target.ref, target.x, target.y)
			FocusFrame:ClearAllPoints()
			FocusFrame:SetPoint(focus.ref, focus.x, focus.y)
			print("Frames moved to default positions. If you were moving arena frames, do a /reload.")
		elseif msg == "hidemacro" then
			if hideMacro == false then
				hideMacro = true
				for i=1,12 do _G["ActionButton"..i.."Name"]:SetAlpha(0) _G["MultiBarBottomRightButton"..i.."Name"]:SetAlpha(0) _G["MultiBarBottomLeftButton"..i.."Name"]:SetAlpha(0) _G["MultiBarRightButton"..i.."Name"]:SetAlpha(0) _G["MultiBarLeftButton"..i.."Name"]:SetAlpha(0) end
			else
				hideMacro = false
				for i=1,12 do _G["ActionButton"..i.."Name"]:SetAlpha(1) _G["MultiBarBottomRightButton"..i.."Name"]:SetAlpha(1) _G["MultiBarBottomLeftButton"..i.."Name"]:SetAlpha(1) _G["MultiBarRightButton"..i.."Name"]:SetAlpha(1) _G["MultiBarLeftButton"..i.."Name"]:SetAlpha(1) end
			end
		elseif msg == "showclass" then
			if showClass == false then
				showClass = true
				ReloadUI()
			else
				showClass = false
				ReloadUI()
			end
		--[[elseif msg == "arena" then
			if not IsAddOnLoaded("Blizzard_ArenaUI") then
				LoadAddOn("Blizzard_ArenaUI")
			end
			ArenaEnemyFrames:Show()
			
			for i=1,5 do _G["ArenaEnemyFrame"..i]:Show()_G["ArenaEnemyFrame"..i.."CastingBar"]:Show()end--_G["ArenaEnemyFrame"..i.."PetFrame"]:Show()end
			
			PositionArenaFrames()]]
		elseif command == "player" and x ~= "" and y ~= "" then
			x, y = tonumber(x), tonumber(y)
			player.ref, player.x, player.y = "CENTER", x, y;
			PlayerFrame:ClearAllPoints();
			PlayerFrame:SetPoint("CENTER", player.x, player.y);
			print("PlayerFrame position moved. Default = -475,175");
		elseif command == "target" and x ~= "" and y ~= "" then
			x, y = tonumber(x), tonumber(y)
			target.ref, target.x, target.y = "CENTER", x, y;
			TargetFrame:ClearAllPoints();
			TargetFrame:SetPoint("CENTER", target.x, target.y);
			print("TargetFrame position moved. Default = -250,175");
		elseif command == "focus" and x ~= "" and y ~= "" then
			x, y = tonumber(x), tonumber(y)
			focus.ref, focus.x, focus.y = "CENTER", x, y;
			FocusFrame:ClearAllPoints();
			FocusFrame:SetPoint("CENTER", focus.x, focus.y);
			print("FocusFrame position moved. Default = 250,175");
		elseif command == "arena" and x ~= "" and y ~= "" then
			x, y = tonumber(x), tonumber(y)
-- PLACEHOLDER TEXT BECAUSE I'M BLIND AS A BAT AWEGAWBAW$EABAWEGHAEGAWEHAWRBAWEAWE
			arena.x, arena.y = x, y;
			if not IsAddOnLoaded("Blizzard_ArenaUI") then
				LoadAddOn("Blizzard_ArenaUI")
			end
			ArenaEnemyFrames:Show()
			for i=1,5 do _G["ArenaEnemyFrame"..i]:Show()_G["ArenaEnemyFrame"..i.."CastingBar"]:Show()end--_G["ArenaEnemyFrame"..i.."PetFrame"]:Show()end
			local arenaFrame
			for i = 1, 5 do
					arenaFrame = _G["ArenaEnemyFrame"..i]		
					arenaFrame.classPortrait:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles")
					arenaFrame.classPortrait:SetTexCoord(unpack(CLASS_ICON_TCOORDS["WARRIOR"]))
					arenaFrame.name:SetText("Dispelme")
					arenaFrame:Show()        			
			end
	 
			for i=1,5 do _G["ArenaEnemyFrame"..i]:ClearAllPoints() end
			ArenaEnemyFrame1:SetPoint("CENTER",UIParent,"CENTER",arena.x,arena.y)
			ArenaEnemyFrame2:SetPoint("CENTER",UIParent,"CENTER",arena.x,arena.y-50)
			ArenaEnemyFrame3:SetPoint("CENTER",UIParent,"CENTER",arena.x,arena.y-100)
			ArenaEnemyFrame4:SetPoint("CENTER",UIParent,"CENTER",arena.x,arena.y-150)
			ArenaEnemyFrame5:SetPoint("CENTER",UIParent,"CENTER",arena.x,arena.y-200)
			ArenaEnemyFrames:SetScale(1.3)
			
			print("ArenaFrame position moved. Once finished, do a /reload. Defaults are 350,50.");
		else
			print("PowerInterface commands: |cFF00FF00/pui |ror |cFF00FF00/powerui |cFFFF0000(Everything is case-sensitive!)|r\ndefaults |cFF00FF00\n--- Sets all frames to default PowerInterface locations.\n|rplayer | target | focus | arena x,y\n|cFF00FF00--- Locks frame to x (horizontal) and y (vertical) ordered pair. 0,0 is the center of your screen.\n|rhidemacro\n|cFF00FF00 --- Hides/Shows macro text on hotkeys.\n|rshowclass |cFF00FF00\n--- Hide/Show class icons or character portraits on frames.\n|rFound a bug? Want a feature? Go to the WoWInterface or Curse page!")
	end
end
SlashCmdList["POWERINTERFACE"] = handler;
plscript:SetScript("OnEvent",eventHandler)
